/*
 *
 *  Copyright (C) 2000 Silicon Graphics, Inc.  All Rights Reserved. 
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  Further, this software is distributed without any warranty that it is
 *  free of the rightful claim of any third person regarding infringement
 *  or the like.  Any license provided herein, whether implied or
 *  otherwise, applies only to this software file.  Patent licenses, if
 *  any, provided herein do not apply to combinations of this program with
 *  other software, or any other product whatsoever.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
 *  Mountain View, CA  94043, or:
 * 
 *  http://www.sgi.com 
 * 
 *  For further information regarding this notice, see: 
 * 
 *  http://oss.sgi.com/projects/GenInfo/NoticeExplan/
 *
 */

/*
 * Copyright (C) 1990,91   Silicon Graphics, Inc.
 *
 _______________________________________________________________________
 ______________  S I L I C O N   G R A P H I C S   I N C .  ____________
 |
 |   $Revision $
 |
 |   Classes:
 |	All elements in one neat little file.
 |
 |   Author(s)		: Paul S. Strauss
 |
 ______________  S I L I C O N   G R A P H I C S   I N C .  ____________
 _______________________________________________________________________
 */


// Initialization file
#include "SoElementInit.cxx"

// Base classes
#include "SoAccumulatedElement.cxx"
#include "SoReplacedElement.cxx"

// Derived classes

       
#include "SoBBoxModelMatrixElement.cxx"
#include "SoCacheElement.cxx"
#include "SoClipPlaneElement.cxx" 
#include "SoComplexityElement.cxx"
#include "SoComplexityTypeElement.cxx"  
#include "SoCoordinateElement.cxx"
#include "SoCreaseAngleElement.cxx"  
#include "SoDrawStyleElement.cxx"
#include "SoFloatElement.cxx"  
#include "SoFocalDistanceElement.cxx"
#include "SoFontNameElement.cxx"  
#include "SoFontSizeElement.cxx"  
#include "SoGLCacheContextElement.cxx"
#include "SoGLClipPlaneElement.cxx"  
#include "SoGLCoordinateElement.cxx"
#include "SoGLDrawStyleElement.cxx"  
#include "SoGLLazyElement.cxx"
#include "SoGLLightIdElement.cxx"  
#include "SoGLLinePatternElement.cxx"
#include "SoGLLineWidthElement.cxx"  
#include "SoGLModelMatrixElement.cxx"
#include "SoGLNormalElement.cxx"  
#include "SoGLPointSizeElement.cxx"  
#include "SoGLProjectionMatrixElement.cxx"
#include "SoGLRenderPassElement.cxx"  
#include "SoGLShapeHintsElement.cxx"  
#include "SoGLTextureCoordinateElement.cxx"
#include "SoGLTextureEnabledElement.cxx"  
#include "SoGLTextureImageElement.cxx"
#include "SoGLTextureMatrixElement.cxx"  
#include "SoGLUpdateAreaElement.cxx"
#include "SoGLViewingMatrixElement.cxx"  
#include "SoGLViewportRegionElement.cxx"
#include "SoLazyElement.cxx"  
#include "SoLightAttenuationElement.cxx"
#include "SoLinePatternElement.cxx"  
#include "SoLineWidthElement.cxx"
#include "SoLocalBBoxMatrixElement.cxx"  
#include "SoInt32Element.cxx"  
#include "SoMaterialBindingElement.cxx"  
#include "SoModelMatrixElement.cxx"
#include "SoNormalBindingElement.cxx"  
#include "SoNormalElement.cxx"
#include "SoOverrideElement.cxx"
#include "SoPickRayElement.cxx"  
#include "SoPickStyleElement.cxx"
#include "SoPointSizeElement.cxx"  
#include "SoProfileCoordinateElement.cxx"
#include "SoProfileElement.cxx"  
#include "SoProjectionMatrixElement.cxx"
#include "SoShapeHintsElement.cxx"  
#include "SoShapeStyleElement.cxx"  
#include "SoSwitchElement.cxx"  
#include "SoTextureCoordinateBindingElement.cxx"
#include "SoTextureCoordinateElement.cxx"  
#include "SoTextureImageElement.cxx"
#include "SoTextureMatrixElement.cxx"  
#include "SoTextureQualityElement.cxx"  
#include "SoUnitsElement.cxx"
#include "SoViewVolumeElement.cxx"  
#include "SoViewingMatrixElement.cxx"
#include "SoViewportRegionElement.cxx"  
#include "SoWindowElement.cxx"
