/**************************************************************************
 *
 *  This file is part of the Coin GUI binding libraries.
 *  Copyright (C) 2000 by Systems in Motion.  All rights reserved.
 *
 *  The libraries this file is part of is free software; you can
 *  redistribute them and/or modify them under the terms of the GNU
 *  Lesser General Public License version 2.1 as published by the
 *  Free Software Foundation.  See the file LICENSE.LGPL at the root
 *  directory of the distribution for all the details.
 *
 *  If you want to use the Coin GUI binding libraries for applications
 *  not compatible with the LGPL, contact SIM about acquiring a
 *  Professional Edition License.
 *
 *  Systems in Motion, Prof Brochs gate 6, N-7030 Trondheim, NORWAY
 *  http://www.sim.no/ support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
 **************************************************************************/

// Generated automatically from SoAnyFullViewer.h.in by configure.
// $Id: SoAnyFullViewer.h.in,v 1.12 2000/09/11 14:58:46 larsa Exp $

#ifndef SOANY_FULLVIEWER_H
#define SOANY_FULLVIEWER_H

#include <Inventor/Qt/viewers/SoQtViewer.h>

class SoEvent;
class SoAnyPopupMenu;
class SoQtFullViewer;

enum SoAnyFullViewerPopupMenuItem {
  ROOT_MENU = 0,
  MENUTITLE_ITEM,

  FUNCTIONS_MENU,
  HELP_ITEM,
  HOME_ITEM,
  SET_HOME_ITEM,
  VIEW_ALL_ITEM,
  SEEK_ITEM,
  COPY_VIEW_ITEM,
  PASTE_VIEW_ITEM,

  DRAWSTYLES_MENU,
  DRAWSTYLES_STILL_MENU,
  AS_IS_ITEM,
  HIDDEN_LINE_ITEM,
  NO_TEXTURE_ITEM,
  LOW_RESOLUTION_ITEM,
  WIREFRAME_ITEM,
  POINTS_ITEM,
  BOUNDING_BOX_ITEM,

  DRAWSTYLES_ANIMATING_MENU,
  MOVE_SAME_AS_STILL_ITEM,
  MOVE_NO_TEXTURE_ITEM,
  MOVE_LOW_RES_ITEM,
  MOVE_WIREFRAME_ITEM,
  MOVE_LOW_RES_WIREFRAME_ITEM,
  MOVE_POINTS_ITEM,
  MOVE_LOW_RES_POINTS_ITEM,
  MOVE_BOUNDING_BOX_ITEM,

  TRANSPARENCY_TYPE_MENU,
  SCREEN_DOOR_TRANSPARENCY_ITEM,
  ADD_TRANSPARENCY_ITEM,
  DELAYED_ADD_TRANSPARENCY_ITEM,
  SORTED_OBJECT_ADD_TRANSPARENCY_ITEM,
  BLEND_TRANSPARENCY_ITEM,
  DELAYED_BLEND_TRANSPARENCY_ITEM,
  SORTED_OBJECT_BLEND_TRANSPARENCY_ITEM,

  RENDER_BUFFER_TYPE_MENU,
  SINGLE_BUFFER_ITEM,
  DOUBLE_BUFFER_ITEM,
  INTERACTIVE_BUFFER_ITEM,

  EXAMINING_ITEM,
  DECORATION_ITEM,
  HEADLIGHT_ITEM,
  PREFERENCES_ITEM,

  STEREO_MENU,
  STEREO_OFF_ITEM,
  STEREO_ANAGLYPH_ITEM
}; // enum SoViewerPopupMenuItem

enum SoViewerPopupMenuRadioGroup {
  STILL_GROUP = 1,
  MOVE_GROUP,
  TRANSPARENCY_GROUP,
  BUFFER_GROUP,
  STEREO_GROUP
}; // enum SoViewerPopupMenuRadioGroup

// ************************************************************************

class SoAnyFullViewer {
public:
  SoAnyFullViewer( SoQtFullViewer * const viewer );
  ~SoAnyFullViewer(void);

  SoAnyPopupMenu * setupStandardPopupMenu(void);

  void setDrawStyleMenuActivation(
    SoQtViewer::DrawType type,
    SoQtViewer::DrawStyle value );

  void drawstyleActivated( int menuitemid );

  void menuSelection( int menuitemid );
  static void menuSelectionCallback( int menuitemid, void * userdata );

  SbBool processSoEvent( const SoEvent * const event );

private:
  SoQtFullViewer * const viewer;
  SoAnyPopupMenu * prefmenu;

}; // class SoAnyFullViewer

// ************************************************************************

#endif // ! SOANY_FULLVIEWER_H
