/**************************************************************************
 *
 *  This file is part of the Coin GUI binding libraries.
 *  Copyright (C) 2000 by Systems in Motion.  All rights reserved.
 *
 *  The libraries this file is part of is free software; you can
 *  redistribute them and/or modify them under the terms of the GNU
 *  Lesser General Public License version 2.1 as published by the
 *  Free Software Foundation.  See the file LICENSE.LGPL at the root
 *  directory of the distribution for all the details.
 *
 *  If you want to use the Coin GUI binding libraries for applications
 *  not compatible with the LGPL, contact SIM about acquiring a
 *  Professional Edition License.
 *
 *  Systems in Motion, Prof Brochs gate 6, N-7030 Trondheim, NORWAY
 *  http://www.sim.no/ support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
 **************************************************************************/

// Generated automatically from SoAnyPopupMenu.h.in by configure.
// $Id: SoAnyPopupMenu.h.in,v 1.9 2000/09/11 14:58:47 larsa Exp $

#ifndef SOANY_POPUPMENU_H
#define SOANY_POPUPMENU_H

#include <Inventor/SbBasic.h>

#include <Inventor/Qt/SoQtComponent.h>

class SbIntList;
class SbPList;

// *************************************************************************

typedef void SoAnyMenuSelectionCallback( int itemid, void * user );

class SoAnyPopupMenu { // abstract interface class
public:
  SoAnyPopupMenu(void);
  virtual ~SoAnyPopupMenu(void);

  virtual int NewMenu( char * name, int menuid = -1 ) = 0;
  virtual int GetMenu( char * name ) = 0;
  virtual void SetMenuTitle( int id, char * title ) = 0;
  virtual char * GetMenuTitle( int id ) = 0;

  virtual int NewMenuItem( char * name, int itemid = -1 ) = 0;
  virtual int GetMenuItem( char * name ) = 0;
  virtual void SetMenuItemTitle( int itemid, char * title ) = 0;
  virtual char * GetMenuItemTitle( int itemid ) = 0;
  virtual void SetMenuItemEnabled( int itemid, SbBool enabled ) = 0;
  virtual SbBool GetMenuItemEnabled( int itemid ) = 0;
  void SetMenuItemMarked( int itemid, SbBool marked );
  virtual SbBool GetMenuItemMarked( int itemid ) = 0;

  virtual void AddMenu( int menuid, int submenuid, int pos = -1 ) = 0;
  virtual void AddMenuItem( int menuid, int itemid, int pos = -1 ) = 0;
  virtual void AddSeparator( int menuid, int pos = -1 ) = 0;
  virtual void RemoveMenu( int menuid ) = 0;
  virtual void RemoveMenuItem( int itemid ) = 0;

  virtual void PopUp( QWidget * inside, int x, int y ) = 0;

  int NewRadioGroup( int groupid = -1 );
  int GetRadioGroup( int itemid );
  int GetRadioGroupSize( int groupid );
  void AddRadioGroupItem( int groupid, int itemid );
  void RemoveRadioGroupItem( int itemid );

  void SetRadioGroupMarkedItem( int itemid );
  int GetRadioGroupMarkedItem( int groupid );

  void AddMenuSelectionCallback(
    SoAnyMenuSelectionCallback * callback, void * data );
  void RemoveMenuSelectionCallback(
    SoAnyMenuSelectionCallback * callback, void * data );

protected:
  virtual void _setMenuItemMarked( int itemid, SbBool marked ) = 0;

  void InvokeMenuSelection( int itemid );

private:
  SbIntList * menuitems;
  SbIntList * radiogroups;
  SbPList * callbacks;
  SbPList * userdata;

}; // class SoAnyPopupMenu

// *************************************************************************

#endif // ! SOANY_POPUPMENU_H
